; Script generated by the Inno Setup Script Wizard.
; SEE THE DOCUMENTATION FOR DETAILS ON CREATING INNO SETUP SCRIPT FILES!

#define MyAppName "Magic Packet Server"
#define MyAppVersion "1.1.0"
#define MyAppPublisher "Nikita Somenkov"
#define MyAppURL "https://apps.somenkov.ru/magic-packet/server"

[Setup]
; NOTE: The value of AppId uniquely identifies this application. Do not use the same AppId value in installers for other applications.
; (To generate a new GUID, click Tools | Generate GUID inside the IDE.)
AppId={{D1F54BD4-3141-452C-861B-DE2D938A7EBC}
AppName={#MyAppName}
AppVersion={#MyAppVersion}
;AppVerName={#MyAppName} {#MyAppVersion}
AppPublisher={#MyAppPublisher}
AppPublisherURL={#MyAppURL}
AppSupportURL={#MyAppURL}
AppUpdatesURL={#MyAppURL}
DefaultDirName={autopf}\{#MyAppName}
DefaultGroupName={#MyAppName}
UninstallDisplayName={#MyAppName}
UninstallDisplayIcon={app}\mpserver.exe
UninstallFilesDir={app}\uninstall
AllowNoIcons=yes
; Uncomment the following line to run in non administrative install mode (install for current user only.)
;PrivilegesRequired=lowest
OutputDir="..\..\dist\windows"
OutputBaseFilename=mpserver-installer
SetupIconFile="..\..\installer\resources\magic-packet-icon.ico"
Compression=lzma
SolidCompression=yes
WizardStyle=modern
ArchitecturesInstallIn64BitMode=x64

[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"

[Files]
Source: "..\..\dist\windows\mpserver.exe"; DestDir: "{app}"; Flags: ignoreversion recursesubdirs createallsubdirs
Source: "..\..\dist\windows\mpworker.exe"; DestDir: "{app}"; Flags: ignoreversion recursesubdirs createallsubdirs
Source: "start.bat"; DestDir: "{app}"; Flags: ignoreversion recursesubdirs; AfterInstall: MyAfterInstall
Source: "Readme.txt"; DestDir: "{app}"; Flags: isreadme

[Code]
function StopServices(): Boolean;
var
  ResultCode: Integer;
begin
  Log('Stop services');
  Result := Exec('sc', 'stop mpserver', '', SW_HIDE, ewWaitUntilTerminated, ResultCode)
  if Result = False then
    MsgBox('Failed to stop mpserver service. Please kill it manually and try again.', mbInformation, MB_OK);
  sleep(2000)
  Result := Exec('sc', 'stop mpworker', '', SW_HIDE, ewWaitUntilTerminated, ResultCode)
  if Result = False then
    MsgBox('Failed to stop mpworker service. Please kill it manually and try again.', mbInformation, MB_OK);
  sleep(2000)
end;

procedure StartServices();
var
  ResultCode: Integer;
begin
  Log('Start services');
  Exec('sc', 'start mpworker', '', SW_HIDE, ewWaitUntilTerminated, ResultCode)
  Exec('sc', 'start mpserver', '', SW_HIDE, ewWaitUntilTerminated, ResultCode)
end;

function DeleteServices(): Boolean;
var
  ResultCode: Integer;
begin
  Log('Delete services');
  Result := Exec('sc', 'delete mpserver', '', SW_HIDE, ewWaitUntilTerminated, ResultCode)
  if Result = False then
    MsgBox('Failed to delete mpserver service. Please delete it manually and try again.', mbInformation, MB_OK);
  Result := Exec('sc', 'delete mpworker', '', SW_HIDE, ewWaitUntilTerminated, ResultCode)
  if Result = False then
    MsgBox('Failed to delete mpworker service. Please delete it manually and try again.', mbInformation, MB_OK);
end;

function AddFirewallRule(): Boolean;
var
  ResultCode: Integer;
begin
  Log('Add firewall rule.')
  Exec('netsh', 'advfirewall firewall delete rule name="Magic Packet Server"', '', SW_HIDE, ewWaitUntilTerminated, ResultCode) 
  Result := Exec('netsh', ExpandConstant('advfirewall firewall add rule name="Magic Packet Server" dir=in action=allow program="{app}\mpserver.exe" enable=yes'),'', 
                 SW_HIDE, ewWaitUntilTerminated, ResultCode)
end;

function InitializeSetup(): Boolean;
begin
  Result := StopServices()
end;

function PrepareToInstall(var NeedsRestart: Boolean): String;
begin
  if AddFirewallRule() = False then
    Result := 'Failed to add firewall rule. Server can not work correctly and will not be install. Please contact support (somenkov.nikita@icloud.com).'
  else
    Result := ''; 
end;

procedure InitializeUninstallProgressForm();
begin
  StopServices()
  DeleteServices()
end;

procedure CancelButtonClick(CurPageID: Integer; var Cancel, Confirm: Boolean);
var
  msgConfirm: Boolean;
begin
  Cancel := ExitSetupMsgBox()
  if Cancel = True then begin
    StartServices()
  end;
  Confirm := False;
end;

procedure MyAfterInstall();
var
  ResultCode: Integer;
  Description: String;
  Res: Boolean;
begin
  if Exec(ExpandConstant('{app}') + '\start.bat', '', '', SW_SHOW, ewWaitUntilTerminated, ResultCode) = False then
  begin
    Description := SysErrorMessage(ResultCode)
    MsgBox(SysErrorMessage(ResultCode), mbError, MB_OK);
    WizardForm.Close;
  end;
end;



